Unit IAH1R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure IAH1R(A :Real; B :Real; var C :Array of Real; N :Integer;
                FUNC :Func_F1; var RF :Array of Real);

implementation

procedure IAH1R(A :Real; B :Real; var C :Array of Real; N :Integer;
                FUNC :Func_F1; var RF :Array of Real);
var
J,K :Integer;
SUM,BMA,BPA,Y,FAC :Real;
const
SYS001 :Real = 3.1415926535897932384626433832795;
label
_10,_30,_20;
begin
BMA := (B-A)*0.5;
BPA := (B+A)*0.5;
for K:=1 to N do
 begin
  Y := Cos(SYS001*(K-0.5)/N);
  RF[K-1] := FUNC(Y*BMA+BPA);
_10:
 end;
FAC := 2.0/N;
for J:=1 to N do
 begin
  SUM := 0.0;
  for K:=1 to N do
   begin
    SUM := SUM+RF[K-1]*Cos((SYS001*(J-1))*((K-0.5)/N));
_30:
   end;
  C[J-1] := FAC*SUM;
_20:
 end;
end;

end.
